package practice5;

import java.io.IOException;

import javax.jdo.PersistenceManager;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;
import com.google.gdata.client.authn.oauth.GoogleOAuthHelper;
import com.google.gdata.client.authn.oauth.GoogleOAuthParameters;
import com.google.gdata.client.authn.oauth.OAuthException;
import com.google.gdata.client.authn.oauth.OAuthHmacSha1Signer;
import com.google.gdata.client.authn.oauth.OAuthSigner;

public class TokenRequestServlet extends HttpServlet {

	public void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {

		UserService userService = UserServiceFactory.getUserService();

		if (userService.isUserLoggedIn()) {

			String consumerKey = "anonymous";
			String consumerSecret = "anonymous";
			String scope = "http://www.google.com/calendar/feeds/";
			String callback = "http://localhost:8888/tokencallback";

			GoogleOAuthParameters oauthParameters = new GoogleOAuthParameters();
			oauthParameters.setOAuthConsumerKey(consumerKey);
			oauthParameters.setOAuthConsumerSecret(consumerSecret);
			oauthParameters.setScope(scope);
			oauthParameters.setOAuthCallback(callback);

			OAuthSigner signer = new OAuthHmacSha1Signer();
			GoogleOAuthHelper oauthHelper = new GoogleOAuthHelper(signer);

			try {
				oauthHelper.getUnauthorizedRequestToken(oauthParameters);
				String approvalPageUrl = oauthHelper.createUserAuthorizationUrl(oauthParameters);
				req.getSession().setAttribute("tokenSecret", oauthParameters.getOAuthTokenSecret());
				resp.sendRedirect(approvalPageUrl);
				return;
			} catch (OAuthException e) {
				e.printStackTrace();
			}
		}

		resp.sendRedirect("/");

	}
}