package practice5;

import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import javax.jdo.JDOObjectNotFoundException;
import javax.jdo.PersistenceManager;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;
import com.google.gdata.client.authn.oauth.GoogleOAuthHelper;
import com.google.gdata.client.authn.oauth.GoogleOAuthParameters;
import com.google.gdata.client.authn.oauth.OAuthException;
import com.google.gdata.client.authn.oauth.OAuthHmacSha1Signer;
import com.google.gdata.client.authn.oauth.OAuthSigner;

public class TokenRevokeServlet extends HttpServlet {

    public void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
    	
		UserService userService = UserServiceFactory.getUserService();
		User user = userService.getCurrentUser();
		
		if (userService.isUserLoggedIn()) {
			String email = user.getEmail();
			
			GoogleOAuthParameters oauthParameters = new GoogleOAuthParameters();
			oauthParameters.setOAuthConsumerKey("anonymous");
			oauthParameters.setOAuthConsumerSecret("anonymous");
			
			PersistenceManager pm = PMF.get().getPersistenceManager();
			try {
				Token token = pm.getObjectById(Token.class, email);
				oauthParameters.setOAuthToken(token.getToken());
				oauthParameters.setOAuthTokenSecret(token.getTokenSecret());
				pm.deletePersistent(token);
			}
			catch(JDOObjectNotFoundException e) {
				resp.sendRedirect(userService.createLogoutURL("/"));
				return;
			}
			finally {
				pm.close();
			}
			
			OAuthSigner signer = new OAuthHmacSha1Signer();
			GoogleOAuthHelper oauthHelper = new GoogleOAuthHelper(signer);
			try {
				oauthHelper.revokeToken(oauthParameters);
			} 
			catch (OAuthException e) {
				e.printStackTrace();
			} 

			resp.sendRedirect(userService.createLogoutURL("/"));
		}
    	else {
    		req.setAttribute("url", userService.createLoginURL("/"));
        	RequestDispatcher rd = req.getRequestDispatcher("/calendars.jsp");
        	rd.forward(req, resp);
    	}
    
    }
    
    public void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
    	doGet(req, resp);
    }
}